<?php
  class IzyEncrypter
  {
    
    public  $key            = 'izyoption',
            $check          = 'check';
    private $characters     = '1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxz';

     
    
    public function __construct( $key = '' )
    {
      if($key) $this->key   = $key;
      $this->characters     = str_replace(str_split($this->key), '', $this->characters);
    }
           
    // encrypt data
    public function encrypt( $text )
    {
      $text                .= $this->check;
      $length               = strlen($text);
      
      $en_text              = array();
      for( $i=0; $i<$length; $i++ )
      {
        $each               = $text{$i};
        $value	            = ord($each);
        array_push($en_text,$this->forLoopGenHelper($each,$value));
      }
      return trim(implode('',$en_text), $this->key);
    }
    
    // decrypt data
    public function decrypt( $text )
    {
      $key                  = $this->key;
      $text   	            = str_replace(str_split($key),'-', $text);  
      $text                 = explode('-', $text);
      $t_count              = count( $text );
      $arr_word             = array();
      
      for( $i=0; $i<$t_count; $i++ )
      {
				array_push($arr_word, $this->forLoopChkHelper( $text{$i} ));
      }
      $text                 = implode('', $arr_word);

      $p                    = strpos($text,$this->check);
      if(!$p || $p<0) return '';
      else return substr($text,0, - strlen($this->check));
      
    }
    
    // helper function for encryption
    private function forLoopGenHelper($t , $v)
    {
			$sep		              = $this->key;
      $key_len              = strlen($sep) - 1;
      $let_len              = strlen($this->characters) - 1;
			$sum		              = 0;
			$ordval		            = array();
			$chrval		            = array();

			while(true)
			{ 
				if($sum > $v)
				{
					array_pop($ordval);
					array_pop($chrval);

					$fval		          = $v - array_sum($ordval);
					array_push($ordval,$fval);
					array_push($chrval,$this->characters{$fval});
					return implode('',$chrval).$sep{mt_rand(0,$key_len)};
				}
				else
				{
					$rand		          = mt_rand(0,$let_len);
					array_push($ordval,$rand);
					$rantx		        = $this->characters{$rand};
					array_push($chrval,$rantx);
					$sum		          = array_sum($ordval);
				}
			}
    }
    
    // helper function for decryption
		private function forLoopChkHelper( $w )
		{ 
			$arr_let		          = $this->characters;
			$ntr			            = array();
			$c				            = strlen($w);

			for( $i=0; $i<$c; $i++)
			{
				array_push($ntr, strpos($arr_let, $w{$i}));
			}	
			return chr(array_sum($ntr));
		}
    
  }
  
  ?>